.286
.model tiny

.code
   org 100h

_entry:
   jmp start

   message db 'Hello World!$'

start:

; Select 640x480 graphics mode.
	mov     ax,012h
	int     10h
	mov     ax,0A000h				; ax = a000
	mov     es,ax				; point es to video memory

;SC_INDEX        equ     3c4h    ;SC index register
;SC_MAP_MASK     equ     2       ;SC map mask register
;SETSC   SC_MAP_MASK,02h         ;map mask setting enables only

;SETSC   macro   INDEX, SETTING
        mov     dx,3c4h
        mov     al,2
        out     dx,al
        inc     dx
        mov     al,02h
        out     dx,al
        dec     dx
;        endm
        sub     di,di           ;start at beginning of video memory
        mov     al,0ffh
        mov     bp,24           ;# bars to draw
HorzBarLoop:
        mov     cx,80*10        ;# bytes per horizontal bar
        rep stosb               ;draw bar
        add     di,80*10        ;point to start of next bar
        dec     bp
        jnz     HorzBarLoop

;        SETSC   SC_MAP_MASK,01h         ;map mask setting enables only
                                        ; plane 0, the blue plane
        mov     dx,3c4h
        mov     al,2
        out     dx,al
        inc     dx
        mov     al,01h
        out     dx,al
        dec     dx

        sub     di,di
        mov     cx,80*480               ;# bytes per screen
        mov     al,0ffh
        rep stosb                       ;perform fill (affects only
                                        ; plane 0, the blue plane)

; Wait for a keystroke.
        mov     ah,1
        int     21h

; Restore text mode.
        mov     ax,03h
        int     10h

; Display Hello World Message.
	mov dx, offset message
	mov ah, 09
	int 21h

; Return to Dos
	mov ax, 4c00h
	int 21h

end _entry
